package com.benyanyi.okhttp;

import android.annotation.SuppressLint;
import android.content.Context;

import com.benyanyi.okhttp.listener.OnOkHttpListener;

import java.util.Map;

/**
 * @author myLove
 */

public class XmlRequest {
    @SuppressLint("StaticFieldLeak")
    private static XmlRequest instance;
    private static String url;
    @SuppressLint("StaticFieldLeak")
    private static Context mContext;
    private static RequestType requestType;

    private XmlRequest() {
    }

    public static XmlRequest getInstance(Context context, String str, RequestType type) {
        if (instance == null) {
            synchronized (XmlRequest.class) {
                if (instance == null) {
                    instance = new XmlRequest();
                }
            }
        }
        mContext = context;
        url = str;
        requestType = type;
        return instance;
    }

    public void sync(Map<Object, Object> map, OnOkHttpListener onOkHttpListener) {
        ObservableRequest.getInstance(mContext, requestType, CallType.SYNC).request(url, map, onOkHttpListener);
    }

    public void async(Map<Object, Object> map, OnOkHttpListener onOkHttpListener) {
        ObservableRequest.getInstance(mContext, requestType, CallType.ASYNC).request(url, map, onOkHttpListener);
    }
}
